// ChipIDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ChipID.h"
#include "ChipIDDlg.h"
#include "FTChipID.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChipIDDlg dialog

CChipIDDlg::CChipIDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChipIDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChipIDDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CChipIDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChipIDDlg)
	DDX_Control(pDX, IDC_CHIP_LIST, m_ChipList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChipIDDlg, CDialog)
	//{{AFX_MSG_MAP(CChipIDDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_FIND_DEVICES, OnFindDevices)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChipIDDlg message handlers

BOOL CChipIDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	char Version[100];

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ChipList.InsertColumn(0, _T("Number"), LVCFMT_LEFT, 20);
	m_ChipList.InsertColumn(1, _T("Serial"), LVCFMT_LEFT, 60);
	m_ChipList.InsertColumn(2, _T("Description"), LVCFMT_LEFT, 150);
	m_ChipList.InsertColumn(3, _T("LocationID"), LVCFMT_LEFT, 80);
	m_ChipList.InsertColumn(4, _T("ChipID"), LVCFMT_LEFT, 80);

	FTID_GetDllVersion(Version, 100);

	SetDlgItemText(IDC_DLL_VERSION, Version);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CChipIDDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChipIDDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChipIDDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CChipIDDlg::OnFindDevices() 
{
	unsigned long NumDevices = 0, LocID = 0, ChipID = 0;
	char SerialNumber[256], Description[256], ErrorMessage[256];
	CString str;
	FTID_STATUS dStatus;

	m_ChipList.DeleteAllItems();
	
	dStatus = FTID_GetNumDevices(&NumDevices);

	if((dStatus == FTID_SUCCESS) && NumDevices) {

		for(int i = 0; i < NumDevices; i++) {
			str.Format("%d", i); 
			m_ChipList.InsertItem(i, str, i);

			dStatus = FTID_GetDeviceSerialNumber(i, SerialNumber, 256);
			if(dStatus == FTID_SUCCESS) {
				m_ChipList.SetItemText(i, 1, SerialNumber);
			}

			dStatus = FTID_GetDeviceDescription(i, Description, 256);
			if(dStatus == FTID_SUCCESS) {
				m_ChipList.SetItemText(i, 2, Description);
			}

			dStatus = FTID_GetDeviceLocationID(i, &LocID);
			if(dStatus == FTID_SUCCESS) {
				str.Format("0x%08lX", LocID); 
				m_ChipList.SetItemText(i, 3, str);
			}

			dStatus = FTID_GetDeviceChipID(i, &ChipID);
			if(dStatus == FTID_SUCCESS) {
				str.Format("0x%08lX", ChipID); 
				m_ChipList.SetItemText(i, 4, str);
			}
		}
	}

	if(dStatus != FTID_SUCCESS) {
		FTID_GetErrorCodeString("EN", dStatus, ErrorMessage, 256);
		MessageBox(ErrorMessage);
	}

}
